// This file was autogenerated by some hot garbage in the `uniffi` crate.
// Trust me, you don't want to mess with it!
import Foundation

// Depending on the consumer's build setup, the low-level FFI code
// might be in a separate module, or it might be compiled inline into
// this module. This is a bit of light hackery to work with both.
#if canImport(MozillaRustComponents)
    import MozillaRustComponents
#endif

private extension RustBuffer {
    // Allocate a new buffer, copying the contents of a `UInt8` array.
    init(bytes: [UInt8]) {
        let rbuf = bytes.withUnsafeBufferPointer { ptr in
            RustBuffer.from(ptr)
        }
        self.init(capacity: rbuf.capacity, len: rbuf.len, data: rbuf.data)
    }

    static func from(_ ptr: UnsafeBufferPointer<UInt8>) -> RustBuffer {
        try! rustCall { ffi_nimbus_afbf_rustbuffer_from_bytes(ForeignBytes(bufferPointer: ptr), $0) }
    }

    // Frees the buffer in place.
    // The buffer must not be used after this is called.
    func deallocate() {
        try! rustCall { ffi_nimbus_afbf_rustbuffer_free(self, $0) }
    }
}

private extension ForeignBytes {
    init(bufferPointer: UnsafeBufferPointer<UInt8>) {
        self.init(len: Int32(bufferPointer.count), data: bufferPointer.baseAddress)
    }
}

// For every type used in the interface, we provide helper methods for conveniently
// lifting and lowering that type from C-compatible data, and for reading and writing
// values of that type in a buffer.

// Helper classes/extensions that don't change.
// Someday, this will be in a libray of its own.

private extension Data {
    init(rustBuffer: RustBuffer) {
        // TODO: This copies the buffer. Can we read directly from a
        // Rust buffer?
        self.init(bytes: rustBuffer.data!, count: Int(rustBuffer.len))
    }
}

// A helper class to read values out of a byte buffer.
private class Reader {
    let data: Data
    var offset: Data.Index

    init(data: Data) {
        self.data = data
        offset = 0
    }

    // Reads an integer at the current offset, in big-endian order, and advances
    // the offset on success. Throws if reading the integer would move the
    // offset past the end of the buffer.
    func readInt<T: FixedWidthInteger>() throws -> T {
        let range = offset ..< offset + MemoryLayout<T>.size
        guard data.count >= range.upperBound else {
            throw UniffiInternalError.bufferOverflow
        }
        if T.self == UInt8.self {
            let value = data[offset]
            offset += 1
            return value as! T
        }
        var value: T = 0
        let _ = withUnsafeMutableBytes(of: &value) { data.copyBytes(to: $0, from: range) }
        offset = range.upperBound
        return value.bigEndian
    }

    // Reads an arbitrary number of bytes, to be used to read
    // raw bytes, this is useful when lifting strings
    func readBytes(count: Int) throws -> [UInt8] {
        let range = offset ..< (offset + count)
        guard data.count >= range.upperBound else {
            throw UniffiInternalError.bufferOverflow
        }
        var value = [UInt8](repeating: 0, count: count)
        value.withUnsafeMutableBufferPointer { buffer in
            data.copyBytes(to: buffer, from: range)
        }
        offset = range.upperBound
        return value
    }

    // Reads a float at the current offset.
    @inlinable
    func readFloat() throws -> Float {
        return Float(bitPattern: try readInt())
    }

    // Reads a float at the current offset.
    @inlinable
    func readDouble() throws -> Double {
        return Double(bitPattern: try readInt())
    }

    // Indicates if the offset has reached the end of the buffer.
    @inlinable
    func hasRemaining() -> Bool {
        return offset < data.count
    }
}

// A helper class to write values into a byte buffer.
private class Writer {
    var bytes: [UInt8]
    var offset: Array<UInt8>.Index

    init() {
        bytes = []
        offset = 0
    }

    func writeBytes<S>(_ byteArr: S) where S: Sequence, S.Element == UInt8 {
        bytes.append(contentsOf: byteArr)
    }

    // Writes an integer in big-endian order.
    //
    // Warning: make sure what you are trying to write
    // is in the correct type!
    func writeInt<T: FixedWidthInteger>(_ value: T) {
        var value = value.bigEndian
        withUnsafeBytes(of: &value) { bytes.append(contentsOf: $0) }
    }

    @inlinable
    func writeFloat(_ value: Float) {
        writeInt(value.bitPattern)
    }

    @inlinable
    func writeDouble(_ value: Double) {
        writeInt(value.bitPattern)
    }
}

// Protocol for types that transfer other types across the FFI. This is
// analogous go the Rust trait of the same name.
private protocol FfiConverter {
    associatedtype FfiType
    associatedtype SwiftType

    static func lift(_ value: FfiType) throws -> SwiftType
    static func lower(_ value: SwiftType) -> FfiType
    static func read(from buf: Reader) throws -> SwiftType
    static func write(_ value: SwiftType, into buf: Writer)
}

// Types conforming to `Primitive` pass themselves directly over the FFI.
private protocol FfiConverterPrimitive: FfiConverter where FfiType == SwiftType {}

extension FfiConverterPrimitive {
    static func lift(_ value: FfiType) throws -> SwiftType {
        return value
    }

    static func lower(_ value: SwiftType) -> FfiType {
        return value
    }
}

// Types conforming to `FfiConverterRustBuffer` lift and lower into a `RustBuffer`.
// Used for complex types where it's hard to write a custom lift/lower.
private protocol FfiConverterRustBuffer: FfiConverter where FfiType == RustBuffer {}

extension FfiConverterRustBuffer {
    static func lift(_ buf: RustBuffer) throws -> SwiftType {
        let reader = Reader(data: Data(rustBuffer: buf))
        let value = try read(from: reader)
        if reader.hasRemaining() {
            throw UniffiInternalError.incompleteData
        }
        buf.deallocate()
        return value
    }

    static func lower(_ value: SwiftType) -> RustBuffer {
        let writer = Writer()
        write(value, into: writer)
        return RustBuffer(bytes: writer.bytes)
    }
}

// An error type for FFI errors. These errors occur at the UniFFI level, not
// the library level.
private enum UniffiInternalError: LocalizedError {
    case bufferOverflow
    case incompleteData
    case unexpectedOptionalTag
    case unexpectedEnumCase
    case unexpectedNullPointer
    case unexpectedRustCallStatusCode
    case unexpectedRustCallError
    case unexpectedStaleHandle
    case rustPanic(_ message: String)

    public var errorDescription: String? {
        switch self {
        case .bufferOverflow: return "Reading the requested value would read past the end of the buffer"
        case .incompleteData: return "The buffer still has data after lifting its containing value"
        case .unexpectedOptionalTag: return "Unexpected optional tag; should be 0 or 1"
        case .unexpectedEnumCase: return "Raw enum value doesn't match any cases"
        case .unexpectedNullPointer: return "Raw pointer value was null"
        case .unexpectedRustCallStatusCode: return "Unexpected RustCallStatus code"
        case .unexpectedRustCallError: return "CALL_ERROR but no errorClass specified"
        case .unexpectedStaleHandle: return "The object in the handle map has been dropped already"
        case let .rustPanic(message): return message
        }
    }
}

private let CALL_SUCCESS: Int8 = 0
private let CALL_ERROR: Int8 = 1
private let CALL_PANIC: Int8 = 2

private extension RustCallStatus {
    init() {
        self.init(
            code: CALL_SUCCESS,
            errorBuf: RustBuffer(
                capacity: 0,
                len: 0,
                data: nil
            )
        )
    }
}

private func rustCall<T>(_ callback: (UnsafeMutablePointer<RustCallStatus>) -> T) throws -> T {
    try makeRustCall(callback, errorHandler: {
        $0.deallocate()
        return UniffiInternalError.unexpectedRustCallError
    })
}

private func rustCallWithError<T, F: FfiConverter>
(_ errorFfiConverter: F.Type, _ callback: (UnsafeMutablePointer<RustCallStatus>) -> T) throws -> T
    where F.SwiftType: Error, F.FfiType == RustBuffer
{
    try makeRustCall(callback, errorHandler: { try errorFfiConverter.lift($0) })
}

private func makeRustCall<T>(_ callback: (UnsafeMutablePointer<RustCallStatus>) -> T, errorHandler: (RustBuffer) throws -> Error) throws -> T {
    var callStatus = RustCallStatus()
    let returnedVal = callback(&callStatus)
    switch callStatus.code {
    case CALL_SUCCESS:
        return returnedVal

    case CALL_ERROR:
        throw try errorHandler(callStatus.errorBuf)

    case CALL_PANIC:
        // When the rust code sees a panic, it tries to construct a RustBuffer
        // with the message.  But if that code panics, then it just sends back
        // an empty buffer.
        if callStatus.errorBuf.len > 0 {
            throw UniffiInternalError.rustPanic(try FfiConverterString.lift(callStatus.errorBuf))
        } else {
            callStatus.errorBuf.deallocate()
            throw UniffiInternalError.rustPanic("Rust panic")
        }

    default:
        throw UniffiInternalError.unexpectedRustCallStatusCode
    }
}

// Public interface members begin here.

private struct FfiConverterInt8: FfiConverterPrimitive {
    typealias FfiType = Int8
    typealias SwiftType = Int8

    static func read(from buf: Reader) throws -> Int8 {
        return try lift(buf.readInt())
    }

    static func write(_ value: Int8, into buf: Writer) {
        buf.writeInt(lower(value))
    }
}

private struct FfiConverterInt32: FfiConverterPrimitive {
    typealias FfiType = Int32
    typealias SwiftType = Int32

    static func read(from buf: Reader) throws -> Int32 {
        return try lift(buf.readInt())
    }

    static func write(_ value: Int32, into buf: Writer) {
        buf.writeInt(lower(value))
    }
}

private struct FfiConverterInt64: FfiConverterPrimitive {
    typealias FfiType = Int64
    typealias SwiftType = Int64

    static func read(from buf: Reader) throws -> Int64 {
        return try lift(buf.readInt())
    }

    static func write(_ value: Int64, into buf: Writer) {
        buf.writeInt(lower(value))
    }
}

private struct FfiConverterBool: FfiConverter {
    typealias FfiType = Int8
    typealias SwiftType = Bool

    static func lift(_ value: Int8) throws -> Bool {
        return value != 0
    }

    static func lower(_ value: Bool) -> Int8 {
        return value ? 1 : 0
    }

    static func read(from buf: Reader) throws -> Bool {
        return try lift(buf.readInt())
    }

    static func write(_ value: Bool, into buf: Writer) {
        buf.writeInt(lower(value))
    }
}

private struct FfiConverterString: FfiConverter {
    typealias SwiftType = String
    typealias FfiType = RustBuffer

    static func lift(_ value: RustBuffer) throws -> String {
        defer {
            value.deallocate()
        }
        if value.data == nil {
            return String()
        }
        let bytes = UnsafeBufferPointer<UInt8>(start: value.data!, count: Int(value.len))
        return String(bytes: bytes, encoding: String.Encoding.utf8)!
    }

    static func lower(_ value: String) -> RustBuffer {
        return value.utf8CString.withUnsafeBufferPointer { ptr in
            // The swift string gives us int8_t, we want uint8_t.
            ptr.withMemoryRebound(to: UInt8.self) { ptr in
                // The swift string gives us a trailing null byte, we don't want it.
                let buf = UnsafeBufferPointer(rebasing: ptr.prefix(upTo: ptr.count - 1))
                return RustBuffer.from(buf)
            }
        }
    }

    static func read(from buf: Reader) throws -> String {
        let len: Int32 = try buf.readInt()
        return String(bytes: try buf.readBytes(count: Int(len)), encoding: String.Encoding.utf8)!
    }

    static func write(_ value: String, into buf: Writer) {
        let len = Int32(value.utf8.count)
        buf.writeInt(len)
        buf.writeBytes(value.utf8)
    }
}

public protocol NimbusClientProtocol {
    func initialize() throws
    func getExperimentBranch(id: String) throws -> String?
    func getFeatureConfigVariables(featureId: String) throws -> String?
    func getExperimentBranches(experimentSlug: String) throws -> [ExperimentBranch]
    func getActiveExperiments() throws -> [EnrolledExperiment]
    func getAvailableExperiments() throws -> [AvailableExperiment]
    func getGlobalUserParticipation() throws -> Bool
    func setGlobalUserParticipation(optIn: Bool) throws -> [EnrollmentChangeEvent]
    func updateExperiments() throws -> [EnrollmentChangeEvent]
    func fetchExperiments() throws
    func applyPendingExperiments() throws -> [EnrollmentChangeEvent]
    func setExperimentsLocally(experimentsJson: String) throws
    func optInWithBranch(experimentSlug: String, branch: String) throws -> [EnrollmentChangeEvent]
    func optOut(experimentSlug: String) throws -> [EnrollmentChangeEvent]
    func resetTelemetryIdentifiers(newRandomizationUnits: AvailableRandomizationUnits) throws -> [EnrollmentChangeEvent]
    func createTargetingHelper(additionalContext: JsonObject?) throws -> NimbusTargetingHelper
    func createStringHelper(additionalContext: JsonObject?) throws -> NimbusStringHelper
    func recordEvent(eventId: String) throws
}

public class NimbusClient: NimbusClientProtocol {
    fileprivate let pointer: UnsafeMutableRawPointer

    // TODO: We'd like this to be `private` but for Swifty reasons,
    // we can't implement `FfiConverter` without making this `required` and we can't
    // make it `required` without making it `public`.
    required init(unsafeFromRawPointer pointer: UnsafeMutableRawPointer) {
        self.pointer = pointer
    }

    public convenience init(appCtx: AppContext, dbpath: String, remoteSettingsConfig: RemoteSettingsConfig?, availableRandomizationUnits: AvailableRandomizationUnits) throws {
        self.init(unsafeFromRawPointer: try

            rustCallWithError(FfiConverterTypeNimbusError.self) {
                nimbus_afbf_NimbusClient_new(
                    FfiConverterTypeAppContext.lower(appCtx),
                    FfiConverterString.lower(dbpath),
                    FfiConverterOptionTypeRemoteSettingsConfig.lower(remoteSettingsConfig),
                    FfiConverterTypeAvailableRandomizationUnits.lower(availableRandomizationUnits), $0
                )
            })
    }

    deinit {
        try! rustCall { ffi_nimbus_afbf_NimbusClient_object_free(pointer, $0) }
    }

    public func initialize() throws {
        try
            rustCallWithError(FfiConverterTypeNimbusError.self) {
                nimbus_afbf_NimbusClient_initialize(self.pointer, $0)
            }
    }

    public func getExperimentBranch(id: String) throws -> String? {
        return try FfiConverterOptionString.lift(
            try
                rustCallWithError(FfiConverterTypeNimbusError.self) {
                    nimbus_afbf_NimbusClient_get_experiment_branch(self.pointer,
                                                                   FfiConverterString.lower(id), $0)
                }
        )
    }

    public func getFeatureConfigVariables(featureId: String) throws -> String? {
        return try FfiConverterOptionString.lift(
            try
                rustCallWithError(FfiConverterTypeNimbusError.self) {
                    nimbus_afbf_NimbusClient_get_feature_config_variables(self.pointer,
                                                                          FfiConverterString.lower(featureId), $0)
                }
        )
    }

    public func getExperimentBranches(experimentSlug: String) throws -> [ExperimentBranch] {
        return try FfiConverterSequenceTypeExperimentBranch.lift(
            try
                rustCallWithError(FfiConverterTypeNimbusError.self) {
                    nimbus_afbf_NimbusClient_get_experiment_branches(self.pointer,
                                                                     FfiConverterString.lower(experimentSlug), $0)
                }
        )
    }

    public func getActiveExperiments() throws -> [EnrolledExperiment] {
        return try FfiConverterSequenceTypeEnrolledExperiment.lift(
            try
                rustCallWithError(FfiConverterTypeNimbusError.self) {
                    nimbus_afbf_NimbusClient_get_active_experiments(self.pointer, $0)
                }
        )
    }

    public func getAvailableExperiments() throws -> [AvailableExperiment] {
        return try FfiConverterSequenceTypeAvailableExperiment.lift(
            try
                rustCallWithError(FfiConverterTypeNimbusError.self) {
                    nimbus_afbf_NimbusClient_get_available_experiments(self.pointer, $0)
                }
        )
    }

    public func getGlobalUserParticipation() throws -> Bool {
        return try FfiConverterBool.lift(
            try
                rustCallWithError(FfiConverterTypeNimbusError.self) {
                    nimbus_afbf_NimbusClient_get_global_user_participation(self.pointer, $0)
                }
        )
    }

    public func setGlobalUserParticipation(optIn: Bool) throws -> [EnrollmentChangeEvent] {
        return try FfiConverterSequenceTypeEnrollmentChangeEvent.lift(
            try
                rustCallWithError(FfiConverterTypeNimbusError.self) {
                    nimbus_afbf_NimbusClient_set_global_user_participation(self.pointer,
                                                                           FfiConverterBool.lower(optIn), $0)
                }
        )
    }

    public func updateExperiments() throws -> [EnrollmentChangeEvent] {
        return try FfiConverterSequenceTypeEnrollmentChangeEvent.lift(
            try
                rustCallWithError(FfiConverterTypeNimbusError.self) {
                    nimbus_afbf_NimbusClient_update_experiments(self.pointer, $0)
                }
        )
    }

    public func fetchExperiments() throws {
        try
            rustCallWithError(FfiConverterTypeNimbusError.self) {
                nimbus_afbf_NimbusClient_fetch_experiments(self.pointer, $0)
            }
    }

    public func applyPendingExperiments() throws -> [EnrollmentChangeEvent] {
        return try FfiConverterSequenceTypeEnrollmentChangeEvent.lift(
            try
                rustCallWithError(FfiConverterTypeNimbusError.self) {
                    nimbus_afbf_NimbusClient_apply_pending_experiments(self.pointer, $0)
                }
        )
    }

    public func setExperimentsLocally(experimentsJson: String) throws {
        try
            rustCallWithError(FfiConverterTypeNimbusError.self) {
                nimbus_afbf_NimbusClient_set_experiments_locally(self.pointer,
                                                                 FfiConverterString.lower(experimentsJson), $0)
            }
    }

    public func optInWithBranch(experimentSlug: String, branch: String) throws -> [EnrollmentChangeEvent] {
        return try FfiConverterSequenceTypeEnrollmentChangeEvent.lift(
            try
                rustCallWithError(FfiConverterTypeNimbusError.self) {
                    nimbus_afbf_NimbusClient_opt_in_with_branch(self.pointer,
                                                                FfiConverterString.lower(experimentSlug),
                                                                FfiConverterString.lower(branch), $0)
                }
        )
    }

    public func optOut(experimentSlug: String) throws -> [EnrollmentChangeEvent] {
        return try FfiConverterSequenceTypeEnrollmentChangeEvent.lift(
            try
                rustCallWithError(FfiConverterTypeNimbusError.self) {
                    nimbus_afbf_NimbusClient_opt_out(self.pointer,
                                                     FfiConverterString.lower(experimentSlug), $0)
                }
        )
    }

    public func resetTelemetryIdentifiers(newRandomizationUnits: AvailableRandomizationUnits) throws -> [EnrollmentChangeEvent] {
        return try FfiConverterSequenceTypeEnrollmentChangeEvent.lift(
            try
                rustCallWithError(FfiConverterTypeNimbusError.self) {
                    nimbus_afbf_NimbusClient_reset_telemetry_identifiers(self.pointer,
                                                                         FfiConverterTypeAvailableRandomizationUnits.lower(newRandomizationUnits), $0)
                }
        )
    }

    public func createTargetingHelper(additionalContext: JsonObject? = nil) throws -> NimbusTargetingHelper {
        return try FfiConverterTypeNimbusTargetingHelper.lift(
            try
                rustCallWithError(FfiConverterTypeNimbusError.self) {
                    nimbus_afbf_NimbusClient_create_targeting_helper(self.pointer,
                                                                     FfiConverterOptionTypeJsonObject.lower(additionalContext), $0)
                }
        )
    }

    public func createStringHelper(additionalContext: JsonObject? = nil) throws -> NimbusStringHelper {
        return try FfiConverterTypeNimbusStringHelper.lift(
            try
                rustCallWithError(FfiConverterTypeNimbusError.self) {
                    nimbus_afbf_NimbusClient_create_string_helper(self.pointer,
                                                                  FfiConverterOptionTypeJsonObject.lower(additionalContext), $0)
                }
        )
    }

    public func recordEvent(eventId: String) throws {
        try
            rustCallWithError(FfiConverterTypeNimbusError.self) {
                nimbus_afbf_NimbusClient_record_event(self.pointer,
                                                      FfiConverterString.lower(eventId), $0)
            }
    }
}

private struct FfiConverterTypeNimbusClient: FfiConverter {
    typealias FfiType = UnsafeMutableRawPointer
    typealias SwiftType = NimbusClient

    static func read(from buf: Reader) throws -> NimbusClient {
        let v: UInt64 = try buf.readInt()
        // The Rust code won't compile if a pointer won't fit in a UInt64.
        // We have to go via `UInt` because that's the thing that's the size of a pointer.
        let ptr = UnsafeMutableRawPointer(bitPattern: UInt(truncatingIfNeeded: v))
        if ptr == nil {
            throw UniffiInternalError.unexpectedNullPointer
        }
        return try lift(ptr!)
    }

    static func write(_ value: NimbusClient, into buf: Writer) {
        // This fiddling is because `Int` is the thing that's the same size as a pointer.
        // The Rust code won't compile if a pointer won't fit in a `UInt64`.
        buf.writeInt(UInt64(bitPattern: Int64(Int(bitPattern: lower(value)))))
    }

    static func lift(_ pointer: UnsafeMutableRawPointer) throws -> NimbusClient {
        return NimbusClient(unsafeFromRawPointer: pointer)
    }

    static func lower(_ value: NimbusClient) -> UnsafeMutableRawPointer {
        return value.pointer
    }
}

public protocol NimbusStringHelperProtocol {
    func stringFormat(template: String, uuid: String?) -> String
    func getUuid(template: String) -> String?
}

public class NimbusStringHelper: NimbusStringHelperProtocol {
    fileprivate let pointer: UnsafeMutableRawPointer

    // TODO: We'd like this to be `private` but for Swifty reasons,
    // we can't implement `FfiConverter` without making this `required` and we can't
    // make it `required` without making it `public`.
    required init(unsafeFromRawPointer pointer: UnsafeMutableRawPointer) {
        self.pointer = pointer
    }

    deinit {
        try! rustCall { ffi_nimbus_afbf_NimbusStringHelper_object_free(pointer, $0) }
    }

    public func stringFormat(template: String, uuid: String? = nil) -> String {
        return try! FfiConverterString.lift(
            try!
                rustCall {
                    nimbus_afbf_NimbusStringHelper_string_format(self.pointer,
                                                                 FfiConverterString.lower(template),
                                                                 FfiConverterOptionString.lower(uuid), $0)
                }
        )
    }

    public func getUuid(template: String) -> String? {
        return try! FfiConverterOptionString.lift(
            try!
                rustCall {
                    nimbus_afbf_NimbusStringHelper_get_uuid(self.pointer,
                                                            FfiConverterString.lower(template), $0)
                }
        )
    }
}

private struct FfiConverterTypeNimbusStringHelper: FfiConverter {
    typealias FfiType = UnsafeMutableRawPointer
    typealias SwiftType = NimbusStringHelper

    static func read(from buf: Reader) throws -> NimbusStringHelper {
        let v: UInt64 = try buf.readInt()
        // The Rust code won't compile if a pointer won't fit in a UInt64.
        // We have to go via `UInt` because that's the thing that's the size of a pointer.
        let ptr = UnsafeMutableRawPointer(bitPattern: UInt(truncatingIfNeeded: v))
        if ptr == nil {
            throw UniffiInternalError.unexpectedNullPointer
        }
        return try lift(ptr!)
    }

    static func write(_ value: NimbusStringHelper, into buf: Writer) {
        // This fiddling is because `Int` is the thing that's the same size as a pointer.
        // The Rust code won't compile if a pointer won't fit in a `UInt64`.
        buf.writeInt(UInt64(bitPattern: Int64(Int(bitPattern: lower(value)))))
    }

    static func lift(_ pointer: UnsafeMutableRawPointer) throws -> NimbusStringHelper {
        return NimbusStringHelper(unsafeFromRawPointer: pointer)
    }

    static func lower(_ value: NimbusStringHelper) -> UnsafeMutableRawPointer {
        return value.pointer
    }
}

public protocol NimbusTargetingHelperProtocol {
    func evalJexl(expression: String) throws -> Bool
}

public class NimbusTargetingHelper: NimbusTargetingHelperProtocol {
    fileprivate let pointer: UnsafeMutableRawPointer

    // TODO: We'd like this to be `private` but for Swifty reasons,
    // we can't implement `FfiConverter` without making this `required` and we can't
    // make it `required` without making it `public`.
    required init(unsafeFromRawPointer pointer: UnsafeMutableRawPointer) {
        self.pointer = pointer
    }

    deinit {
        try! rustCall { ffi_nimbus_afbf_NimbusTargetingHelper_object_free(pointer, $0) }
    }

    public func evalJexl(expression: String) throws -> Bool {
        return try FfiConverterBool.lift(
            try
                rustCallWithError(FfiConverterTypeNimbusError.self) {
                    nimbus_afbf_NimbusTargetingHelper_eval_jexl(self.pointer,
                                                                FfiConverterString.lower(expression), $0)
                }
        )
    }
}

private struct FfiConverterTypeNimbusTargetingHelper: FfiConverter {
    typealias FfiType = UnsafeMutableRawPointer
    typealias SwiftType = NimbusTargetingHelper

    static func read(from buf: Reader) throws -> NimbusTargetingHelper {
        let v: UInt64 = try buf.readInt()
        // The Rust code won't compile if a pointer won't fit in a UInt64.
        // We have to go via `UInt` because that's the thing that's the size of a pointer.
        let ptr = UnsafeMutableRawPointer(bitPattern: UInt(truncatingIfNeeded: v))
        if ptr == nil {
            throw UniffiInternalError.unexpectedNullPointer
        }
        return try lift(ptr!)
    }

    static func write(_ value: NimbusTargetingHelper, into buf: Writer) {
        // This fiddling is because `Int` is the thing that's the same size as a pointer.
        // The Rust code won't compile if a pointer won't fit in a `UInt64`.
        buf.writeInt(UInt64(bitPattern: Int64(Int(bitPattern: lower(value)))))
    }

    static func lift(_ pointer: UnsafeMutableRawPointer) throws -> NimbusTargetingHelper {
        return NimbusTargetingHelper(unsafeFromRawPointer: pointer)
    }

    static func lower(_ value: NimbusTargetingHelper) -> UnsafeMutableRawPointer {
        return value.pointer
    }
}

public struct AppContext {
    public var appName: String
    public var appId: String
    public var channel: String
    public var appVersion: String?
    public var appBuild: String?
    public var architecture: String?
    public var deviceManufacturer: String?
    public var deviceModel: String?
    public var locale: String?
    public var os: String?
    public var osVersion: String?
    public var androidSdkVersion: String?
    public var debugTag: String?
    public var installationDate: Int64?
    public var homeDirectory: String?
    public var customTargetingAttributes: JsonObject?

    // Default memberwise initializers are never public by default, so we
    // declare one manually.
    public init(appName: String, appId: String, channel: String, appVersion: String?, appBuild: String?, architecture: String?, deviceManufacturer: String?, deviceModel: String?, locale: String?, os: String?, osVersion: String?, androidSdkVersion: String?, debugTag: String?, installationDate: Int64?, homeDirectory: String?, customTargetingAttributes: JsonObject?) {
        self.appName = appName
        self.appId = appId
        self.channel = channel
        self.appVersion = appVersion
        self.appBuild = appBuild
        self.architecture = architecture
        self.deviceManufacturer = deviceManufacturer
        self.deviceModel = deviceModel
        self.locale = locale
        self.os = os
        self.osVersion = osVersion
        self.androidSdkVersion = androidSdkVersion
        self.debugTag = debugTag
        self.installationDate = installationDate
        self.homeDirectory = homeDirectory
        self.customTargetingAttributes = customTargetingAttributes
    }
}

extension AppContext: Equatable, Hashable {
    public static func == (lhs: AppContext, rhs: AppContext) -> Bool {
        if lhs.appName != rhs.appName {
            return false
        }
        if lhs.appId != rhs.appId {
            return false
        }
        if lhs.channel != rhs.channel {
            return false
        }
        if lhs.appVersion != rhs.appVersion {
            return false
        }
        if lhs.appBuild != rhs.appBuild {
            return false
        }
        if lhs.architecture != rhs.architecture {
            return false
        }
        if lhs.deviceManufacturer != rhs.deviceManufacturer {
            return false
        }
        if lhs.deviceModel != rhs.deviceModel {
            return false
        }
        if lhs.locale != rhs.locale {
            return false
        }
        if lhs.os != rhs.os {
            return false
        }
        if lhs.osVersion != rhs.osVersion {
            return false
        }
        if lhs.androidSdkVersion != rhs.androidSdkVersion {
            return false
        }
        if lhs.debugTag != rhs.debugTag {
            return false
        }
        if lhs.installationDate != rhs.installationDate {
            return false
        }
        if lhs.homeDirectory != rhs.homeDirectory {
            return false
        }
        if lhs.customTargetingAttributes != rhs.customTargetingAttributes {
            return false
        }
        return true
    }

    public func hash(into hasher: inout Hasher) {
        hasher.combine(appName)
        hasher.combine(appId)
        hasher.combine(channel)
        hasher.combine(appVersion)
        hasher.combine(appBuild)
        hasher.combine(architecture)
        hasher.combine(deviceManufacturer)
        hasher.combine(deviceModel)
        hasher.combine(locale)
        hasher.combine(os)
        hasher.combine(osVersion)
        hasher.combine(androidSdkVersion)
        hasher.combine(debugTag)
        hasher.combine(installationDate)
        hasher.combine(homeDirectory)
        hasher.combine(customTargetingAttributes)
    }
}

private struct FfiConverterTypeAppContext: FfiConverterRustBuffer {
    fileprivate static func read(from buf: Reader) throws -> AppContext {
        return try AppContext(
            appName: FfiConverterString.read(from: buf),
            appId: FfiConverterString.read(from: buf),
            channel: FfiConverterString.read(from: buf),
            appVersion: FfiConverterOptionString.read(from: buf),
            appBuild: FfiConverterOptionString.read(from: buf),
            architecture: FfiConverterOptionString.read(from: buf),
            deviceManufacturer: FfiConverterOptionString.read(from: buf),
            deviceModel: FfiConverterOptionString.read(from: buf),
            locale: FfiConverterOptionString.read(from: buf),
            os: FfiConverterOptionString.read(from: buf),
            osVersion: FfiConverterOptionString.read(from: buf),
            androidSdkVersion: FfiConverterOptionString.read(from: buf),
            debugTag: FfiConverterOptionString.read(from: buf),
            installationDate: FfiConverterOptionInt64.read(from: buf),
            homeDirectory: FfiConverterOptionString.read(from: buf),
            customTargetingAttributes: FfiConverterOptionTypeJsonObject.read(from: buf)
        )
    }

    fileprivate static func write(_ value: AppContext, into buf: Writer) {
        FfiConverterString.write(value.appName, into: buf)
        FfiConverterString.write(value.appId, into: buf)
        FfiConverterString.write(value.channel, into: buf)
        FfiConverterOptionString.write(value.appVersion, into: buf)
        FfiConverterOptionString.write(value.appBuild, into: buf)
        FfiConverterOptionString.write(value.architecture, into: buf)
        FfiConverterOptionString.write(value.deviceManufacturer, into: buf)
        FfiConverterOptionString.write(value.deviceModel, into: buf)
        FfiConverterOptionString.write(value.locale, into: buf)
        FfiConverterOptionString.write(value.os, into: buf)
        FfiConverterOptionString.write(value.osVersion, into: buf)
        FfiConverterOptionString.write(value.androidSdkVersion, into: buf)
        FfiConverterOptionString.write(value.debugTag, into: buf)
        FfiConverterOptionInt64.write(value.installationDate, into: buf)
        FfiConverterOptionString.write(value.homeDirectory, into: buf)
        FfiConverterOptionTypeJsonObject.write(value.customTargetingAttributes, into: buf)
    }
}

public struct AvailableExperiment {
    public var slug: String
    public var userFacingName: String
    public var userFacingDescription: String
    public var branches: [ExperimentBranch]
    public var referenceBranch: String?

    // Default memberwise initializers are never public by default, so we
    // declare one manually.
    public init(slug: String, userFacingName: String, userFacingDescription: String, branches: [ExperimentBranch], referenceBranch: String?) {
        self.slug = slug
        self.userFacingName = userFacingName
        self.userFacingDescription = userFacingDescription
        self.branches = branches
        self.referenceBranch = referenceBranch
    }
}

extension AvailableExperiment: Equatable, Hashable {
    public static func == (lhs: AvailableExperiment, rhs: AvailableExperiment) -> Bool {
        if lhs.slug != rhs.slug {
            return false
        }
        if lhs.userFacingName != rhs.userFacingName {
            return false
        }
        if lhs.userFacingDescription != rhs.userFacingDescription {
            return false
        }
        if lhs.branches != rhs.branches {
            return false
        }
        if lhs.referenceBranch != rhs.referenceBranch {
            return false
        }
        return true
    }

    public func hash(into hasher: inout Hasher) {
        hasher.combine(slug)
        hasher.combine(userFacingName)
        hasher.combine(userFacingDescription)
        hasher.combine(branches)
        hasher.combine(referenceBranch)
    }
}

private struct FfiConverterTypeAvailableExperiment: FfiConverterRustBuffer {
    fileprivate static func read(from buf: Reader) throws -> AvailableExperiment {
        return try AvailableExperiment(
            slug: FfiConverterString.read(from: buf),
            userFacingName: FfiConverterString.read(from: buf),
            userFacingDescription: FfiConverterString.read(from: buf),
            branches: FfiConverterSequenceTypeExperimentBranch.read(from: buf),
            referenceBranch: FfiConverterOptionString.read(from: buf)
        )
    }

    fileprivate static func write(_ value: AvailableExperiment, into buf: Writer) {
        FfiConverterString.write(value.slug, into: buf)
        FfiConverterString.write(value.userFacingName, into: buf)
        FfiConverterString.write(value.userFacingDescription, into: buf)
        FfiConverterSequenceTypeExperimentBranch.write(value.branches, into: buf)
        FfiConverterOptionString.write(value.referenceBranch, into: buf)
    }
}

public struct AvailableRandomizationUnits {
    public var clientId: String?
    public var dummy: Int8

    // Default memberwise initializers are never public by default, so we
    // declare one manually.
    public init(clientId: String?, dummy: Int8) {
        self.clientId = clientId
        self.dummy = dummy
    }
}

extension AvailableRandomizationUnits: Equatable, Hashable {
    public static func == (lhs: AvailableRandomizationUnits, rhs: AvailableRandomizationUnits) -> Bool {
        if lhs.clientId != rhs.clientId {
            return false
        }
        if lhs.dummy != rhs.dummy {
            return false
        }
        return true
    }

    public func hash(into hasher: inout Hasher) {
        hasher.combine(clientId)
        hasher.combine(dummy)
    }
}

private struct FfiConverterTypeAvailableRandomizationUnits: FfiConverterRustBuffer {
    fileprivate static func read(from buf: Reader) throws -> AvailableRandomizationUnits {
        return try AvailableRandomizationUnits(
            clientId: FfiConverterOptionString.read(from: buf),
            dummy: FfiConverterInt8.read(from: buf)
        )
    }

    fileprivate static func write(_ value: AvailableRandomizationUnits, into buf: Writer) {
        FfiConverterOptionString.write(value.clientId, into: buf)
        FfiConverterInt8.write(value.dummy, into: buf)
    }
}

public struct EnrolledExperiment {
    public var featureIds: [String]
    public var slug: String
    public var userFacingName: String
    public var userFacingDescription: String
    public var branchSlug: String
    public var enrollmentId: String

    // Default memberwise initializers are never public by default, so we
    // declare one manually.
    public init(featureIds: [String], slug: String, userFacingName: String, userFacingDescription: String, branchSlug: String, enrollmentId: String) {
        self.featureIds = featureIds
        self.slug = slug
        self.userFacingName = userFacingName
        self.userFacingDescription = userFacingDescription
        self.branchSlug = branchSlug
        self.enrollmentId = enrollmentId
    }
}

extension EnrolledExperiment: Equatable, Hashable {
    public static func == (lhs: EnrolledExperiment, rhs: EnrolledExperiment) -> Bool {
        if lhs.featureIds != rhs.featureIds {
            return false
        }
        if lhs.slug != rhs.slug {
            return false
        }
        if lhs.userFacingName != rhs.userFacingName {
            return false
        }
        if lhs.userFacingDescription != rhs.userFacingDescription {
            return false
        }
        if lhs.branchSlug != rhs.branchSlug {
            return false
        }
        if lhs.enrollmentId != rhs.enrollmentId {
            return false
        }
        return true
    }

    public func hash(into hasher: inout Hasher) {
        hasher.combine(featureIds)
        hasher.combine(slug)
        hasher.combine(userFacingName)
        hasher.combine(userFacingDescription)
        hasher.combine(branchSlug)
        hasher.combine(enrollmentId)
    }
}

private struct FfiConverterTypeEnrolledExperiment: FfiConverterRustBuffer {
    fileprivate static func read(from buf: Reader) throws -> EnrolledExperiment {
        return try EnrolledExperiment(
            featureIds: FfiConverterSequenceString.read(from: buf),
            slug: FfiConverterString.read(from: buf),
            userFacingName: FfiConverterString.read(from: buf),
            userFacingDescription: FfiConverterString.read(from: buf),
            branchSlug: FfiConverterString.read(from: buf),
            enrollmentId: FfiConverterString.read(from: buf)
        )
    }

    fileprivate static func write(_ value: EnrolledExperiment, into buf: Writer) {
        FfiConverterSequenceString.write(value.featureIds, into: buf)
        FfiConverterString.write(value.slug, into: buf)
        FfiConverterString.write(value.userFacingName, into: buf)
        FfiConverterString.write(value.userFacingDescription, into: buf)
        FfiConverterString.write(value.branchSlug, into: buf)
        FfiConverterString.write(value.enrollmentId, into: buf)
    }
}

public struct EnrollmentChangeEvent {
    public var experimentSlug: String
    public var branchSlug: String
    public var enrollmentId: String
    public var reason: String?
    public var change: EnrollmentChangeEventType

    // Default memberwise initializers are never public by default, so we
    // declare one manually.
    public init(experimentSlug: String, branchSlug: String, enrollmentId: String, reason: String?, change: EnrollmentChangeEventType) {
        self.experimentSlug = experimentSlug
        self.branchSlug = branchSlug
        self.enrollmentId = enrollmentId
        self.reason = reason
        self.change = change
    }
}

extension EnrollmentChangeEvent: Equatable, Hashable {
    public static func == (lhs: EnrollmentChangeEvent, rhs: EnrollmentChangeEvent) -> Bool {
        if lhs.experimentSlug != rhs.experimentSlug {
            return false
        }
        if lhs.branchSlug != rhs.branchSlug {
            return false
        }
        if lhs.enrollmentId != rhs.enrollmentId {
            return false
        }
        if lhs.reason != rhs.reason {
            return false
        }
        if lhs.change != rhs.change {
            return false
        }
        return true
    }

    public func hash(into hasher: inout Hasher) {
        hasher.combine(experimentSlug)
        hasher.combine(branchSlug)
        hasher.combine(enrollmentId)
        hasher.combine(reason)
        hasher.combine(change)
    }
}

private struct FfiConverterTypeEnrollmentChangeEvent: FfiConverterRustBuffer {
    fileprivate static func read(from buf: Reader) throws -> EnrollmentChangeEvent {
        return try EnrollmentChangeEvent(
            experimentSlug: FfiConverterString.read(from: buf),
            branchSlug: FfiConverterString.read(from: buf),
            enrollmentId: FfiConverterString.read(from: buf),
            reason: FfiConverterOptionString.read(from: buf),
            change: FfiConverterTypeEnrollmentChangeEventType.read(from: buf)
        )
    }

    fileprivate static func write(_ value: EnrollmentChangeEvent, into buf: Writer) {
        FfiConverterString.write(value.experimentSlug, into: buf)
        FfiConverterString.write(value.branchSlug, into: buf)
        FfiConverterString.write(value.enrollmentId, into: buf)
        FfiConverterOptionString.write(value.reason, into: buf)
        FfiConverterTypeEnrollmentChangeEventType.write(value.change, into: buf)
    }
}

public struct ExperimentBranch {
    public var slug: String
    public var ratio: Int32

    // Default memberwise initializers are never public by default, so we
    // declare one manually.
    public init(slug: String, ratio: Int32) {
        self.slug = slug
        self.ratio = ratio
    }
}

extension ExperimentBranch: Equatable, Hashable {
    public static func == (lhs: ExperimentBranch, rhs: ExperimentBranch) -> Bool {
        if lhs.slug != rhs.slug {
            return false
        }
        if lhs.ratio != rhs.ratio {
            return false
        }
        return true
    }

    public func hash(into hasher: inout Hasher) {
        hasher.combine(slug)
        hasher.combine(ratio)
    }
}

private struct FfiConverterTypeExperimentBranch: FfiConverterRustBuffer {
    fileprivate static func read(from buf: Reader) throws -> ExperimentBranch {
        return try ExperimentBranch(
            slug: FfiConverterString.read(from: buf),
            ratio: FfiConverterInt32.read(from: buf)
        )
    }

    fileprivate static func write(_ value: ExperimentBranch, into buf: Writer) {
        FfiConverterString.write(value.slug, into: buf)
        FfiConverterInt32.write(value.ratio, into: buf)
    }
}

public struct RemoteSettingsConfig {
    public var serverUrl: String
    public var collectionName: String

    // Default memberwise initializers are never public by default, so we
    // declare one manually.
    public init(serverUrl: String, collectionName: String) {
        self.serverUrl = serverUrl
        self.collectionName = collectionName
    }
}

extension RemoteSettingsConfig: Equatable, Hashable {
    public static func == (lhs: RemoteSettingsConfig, rhs: RemoteSettingsConfig) -> Bool {
        if lhs.serverUrl != rhs.serverUrl {
            return false
        }
        if lhs.collectionName != rhs.collectionName {
            return false
        }
        return true
    }

    public func hash(into hasher: inout Hasher) {
        hasher.combine(serverUrl)
        hasher.combine(collectionName)
    }
}

private struct FfiConverterTypeRemoteSettingsConfig: FfiConverterRustBuffer {
    fileprivate static func read(from buf: Reader) throws -> RemoteSettingsConfig {
        return try RemoteSettingsConfig(
            serverUrl: FfiConverterString.read(from: buf),
            collectionName: FfiConverterString.read(from: buf)
        )
    }

    fileprivate static func write(_ value: RemoteSettingsConfig, into buf: Writer) {
        FfiConverterString.write(value.serverUrl, into: buf)
        FfiConverterString.write(value.collectionName, into: buf)
    }
}

// Note that we don't yet support `indirect` for enums.
// See https://github.com/mozilla/uniffi-rs/issues/396 for further discussion.
public enum EnrollmentChangeEventType {
    case enrollment
    case enrollFailed
    case disqualification
    case unenrollment
    case unenrollFailed
}

private struct FfiConverterTypeEnrollmentChangeEventType: FfiConverterRustBuffer {
    typealias SwiftType = EnrollmentChangeEventType

    static func read(from buf: Reader) throws -> EnrollmentChangeEventType {
        let variant: Int32 = try buf.readInt()
        switch variant {
        case 1: return .enrollment

        case 2: return .enrollFailed

        case 3: return .disqualification

        case 4: return .unenrollment

        case 5: return .unenrollFailed

        default: throw UniffiInternalError.unexpectedEnumCase
        }
    }

    static func write(_ value: EnrollmentChangeEventType, into buf: Writer) {
        switch value {
        case .enrollment:
            buf.writeInt(Int32(1))

        case .enrollFailed:
            buf.writeInt(Int32(2))

        case .disqualification:
            buf.writeInt(Int32(3))

        case .unenrollment:
            buf.writeInt(Int32(4))

        case .unenrollFailed:
            buf.writeInt(Int32(5))
        }
    }
}

extension EnrollmentChangeEventType: Equatable, Hashable {}

public enum NimbusError {
    // Simple error enums only carry a message
    case InvalidPersistedData(message: String)

    // Simple error enums only carry a message
    case RkvError(message: String)

    // Simple error enums only carry a message
    case IoError(message: String)

    // Simple error enums only carry a message
    case JsonError(message: String)

    // Simple error enums only carry a message
    case EvaluationError(message: String)

    // Simple error enums only carry a message
    case InvalidExpression(message: String)

    // Simple error enums only carry a message
    case InvalidFraction(message: String)

    // Simple error enums only carry a message
    case TryFromSliceError(message: String)

    // Simple error enums only carry a message
    case EmptyRatiosError(message: String)

    // Simple error enums only carry a message
    case OutOfBoundsError(message: String)

    // Simple error enums only carry a message
    case UrlParsingError(message: String)

    // Simple error enums only carry a message
    case RequestError(message: String)

    // Simple error enums only carry a message
    case ResponseError(message: String)

    // Simple error enums only carry a message
    case UuidError(message: String)

    // Simple error enums only carry a message
    case InvalidExperimentFormat(message: String)

    // Simple error enums only carry a message
    case InvalidPath(message: String)

    // Simple error enums only carry a message
    case InternalError(message: String)

    // Simple error enums only carry a message
    case NoSuchExperiment(message: String)

    // Simple error enums only carry a message
    case NoSuchBranch(message: String)

    // Simple error enums only carry a message
    case BackoffError(message: String)

    // Simple error enums only carry a message
    case DatabaseNotReady(message: String)

    // Simple error enums only carry a message
    case VersionParsingError(message: String)

    // Simple error enums only carry a message
    case BehaviorError(message: String)

    // Simple error enums only carry a message
    case TryFromIntError(message: String)

    // Simple error enums only carry a message
    case ParseIntError(message: String)

    // Simple error enums only carry a message
    case TransformParameterError(message: String)
}

private struct FfiConverterTypeNimbusError: FfiConverterRustBuffer {
    typealias SwiftType = NimbusError

    static func read(from buf: Reader) throws -> NimbusError {
        let variant: Int32 = try buf.readInt()
        switch variant {
        case 1: return .InvalidPersistedData(
                message: try FfiConverterString.read(from: buf)
            )

        case 2: return .RkvError(
                message: try FfiConverterString.read(from: buf)
            )

        case 3: return .IoError(
                message: try FfiConverterString.read(from: buf)
            )

        case 4: return .JsonError(
                message: try FfiConverterString.read(from: buf)
            )

        case 5: return .EvaluationError(
                message: try FfiConverterString.read(from: buf)
            )

        case 6: return .InvalidExpression(
                message: try FfiConverterString.read(from: buf)
            )

        case 7: return .InvalidFraction(
                message: try FfiConverterString.read(from: buf)
            )

        case 8: return .TryFromSliceError(
                message: try FfiConverterString.read(from: buf)
            )

        case 9: return .EmptyRatiosError(
                message: try FfiConverterString.read(from: buf)
            )

        case 10: return .OutOfBoundsError(
                message: try FfiConverterString.read(from: buf)
            )

        case 11: return .UrlParsingError(
                message: try FfiConverterString.read(from: buf)
            )

        case 12: return .RequestError(
                message: try FfiConverterString.read(from: buf)
            )

        case 13: return .ResponseError(
                message: try FfiConverterString.read(from: buf)
            )

        case 14: return .UuidError(
                message: try FfiConverterString.read(from: buf)
            )

        case 15: return .InvalidExperimentFormat(
                message: try FfiConverterString.read(from: buf)
            )

        case 16: return .InvalidPath(
                message: try FfiConverterString.read(from: buf)
            )

        case 17: return .InternalError(
                message: try FfiConverterString.read(from: buf)
            )

        case 18: return .NoSuchExperiment(
                message: try FfiConverterString.read(from: buf)
            )

        case 19: return .NoSuchBranch(
                message: try FfiConverterString.read(from: buf)
            )

        case 20: return .BackoffError(
                message: try FfiConverterString.read(from: buf)
            )

        case 21: return .DatabaseNotReady(
                message: try FfiConverterString.read(from: buf)
            )

        case 22: return .VersionParsingError(
                message: try FfiConverterString.read(from: buf)
            )

        case 23: return .BehaviorError(
                message: try FfiConverterString.read(from: buf)
            )

        case 24: return .TryFromIntError(
                message: try FfiConverterString.read(from: buf)
            )

        case 25: return .ParseIntError(
                message: try FfiConverterString.read(from: buf)
            )

        case 26: return .TransformParameterError(
                message: try FfiConverterString.read(from: buf)
            )

        default: throw UniffiInternalError.unexpectedEnumCase
        }
    }

    static func write(_ value: NimbusError, into buf: Writer) {
        switch value {
        case let .InvalidPersistedData(message):
            buf.writeInt(Int32(1))
            FfiConverterString.write(message, into: buf)
        case let .RkvError(message):
            buf.writeInt(Int32(2))
            FfiConverterString.write(message, into: buf)
        case let .IoError(message):
            buf.writeInt(Int32(3))
            FfiConverterString.write(message, into: buf)
        case let .JsonError(message):
            buf.writeInt(Int32(4))
            FfiConverterString.write(message, into: buf)
        case let .EvaluationError(message):
            buf.writeInt(Int32(5))
            FfiConverterString.write(message, into: buf)
        case let .InvalidExpression(message):
            buf.writeInt(Int32(6))
            FfiConverterString.write(message, into: buf)
        case let .InvalidFraction(message):
            buf.writeInt(Int32(7))
            FfiConverterString.write(message, into: buf)
        case let .TryFromSliceError(message):
            buf.writeInt(Int32(8))
            FfiConverterString.write(message, into: buf)
        case let .EmptyRatiosError(message):
            buf.writeInt(Int32(9))
            FfiConverterString.write(message, into: buf)
        case let .OutOfBoundsError(message):
            buf.writeInt(Int32(10))
            FfiConverterString.write(message, into: buf)
        case let .UrlParsingError(message):
            buf.writeInt(Int32(11))
            FfiConverterString.write(message, into: buf)
        case let .RequestError(message):
            buf.writeInt(Int32(12))
            FfiConverterString.write(message, into: buf)
        case let .ResponseError(message):
            buf.writeInt(Int32(13))
            FfiConverterString.write(message, into: buf)
        case let .UuidError(message):
            buf.writeInt(Int32(14))
            FfiConverterString.write(message, into: buf)
        case let .InvalidExperimentFormat(message):
            buf.writeInt(Int32(15))
            FfiConverterString.write(message, into: buf)
        case let .InvalidPath(message):
            buf.writeInt(Int32(16))
            FfiConverterString.write(message, into: buf)
        case let .InternalError(message):
            buf.writeInt(Int32(17))
            FfiConverterString.write(message, into: buf)
        case let .NoSuchExperiment(message):
            buf.writeInt(Int32(18))
            FfiConverterString.write(message, into: buf)
        case let .NoSuchBranch(message):
            buf.writeInt(Int32(19))
            FfiConverterString.write(message, into: buf)
        case let .BackoffError(message):
            buf.writeInt(Int32(20))
            FfiConverterString.write(message, into: buf)
        case let .DatabaseNotReady(message):
            buf.writeInt(Int32(21))
            FfiConverterString.write(message, into: buf)
        case let .VersionParsingError(message):
            buf.writeInt(Int32(22))
            FfiConverterString.write(message, into: buf)
        case let .BehaviorError(message):
            buf.writeInt(Int32(23))
            FfiConverterString.write(message, into: buf)
        case let .TryFromIntError(message):
            buf.writeInt(Int32(24))
            FfiConverterString.write(message, into: buf)
        case let .ParseIntError(message):
            buf.writeInt(Int32(25))
            FfiConverterString.write(message, into: buf)
        case let .TransformParameterError(message):
            buf.writeInt(Int32(26))
            FfiConverterString.write(message, into: buf)
        }
    }
}

extension NimbusError: Equatable, Hashable {}

extension NimbusError: Error {}

private struct FfiConverterOptionInt64: FfiConverterRustBuffer {
    typealias SwiftType = Int64?

    static func write(_ value: SwiftType, into buf: Writer) {
        guard let value = value else {
            buf.writeInt(Int8(0))
            return
        }
        buf.writeInt(Int8(1))
        FfiConverterInt64.write(value, into: buf)
    }

    static func read(from buf: Reader) throws -> SwiftType {
        switch try buf.readInt() as Int8 {
        case 0: return nil
        case 1: return try FfiConverterInt64.read(from: buf)
        default: throw UniffiInternalError.unexpectedOptionalTag
        }
    }
}

private struct FfiConverterOptionString: FfiConverterRustBuffer {
    typealias SwiftType = String?

    static func write(_ value: SwiftType, into buf: Writer) {
        guard let value = value else {
            buf.writeInt(Int8(0))
            return
        }
        buf.writeInt(Int8(1))
        FfiConverterString.write(value, into: buf)
    }

    static func read(from buf: Reader) throws -> SwiftType {
        switch try buf.readInt() as Int8 {
        case 0: return nil
        case 1: return try FfiConverterString.read(from: buf)
        default: throw UniffiInternalError.unexpectedOptionalTag
        }
    }
}

private struct FfiConverterOptionTypeRemoteSettingsConfig: FfiConverterRustBuffer {
    typealias SwiftType = RemoteSettingsConfig?

    static func write(_ value: SwiftType, into buf: Writer) {
        guard let value = value else {
            buf.writeInt(Int8(0))
            return
        }
        buf.writeInt(Int8(1))
        FfiConverterTypeRemoteSettingsConfig.write(value, into: buf)
    }

    static func read(from buf: Reader) throws -> SwiftType {
        switch try buf.readInt() as Int8 {
        case 0: return nil
        case 1: return try FfiConverterTypeRemoteSettingsConfig.read(from: buf)
        default: throw UniffiInternalError.unexpectedOptionalTag
        }
    }
}

private struct FfiConverterOptionTypeJsonObject: FfiConverterRustBuffer {
    typealias SwiftType = JsonObject?

    static func write(_ value: SwiftType, into buf: Writer) {
        guard let value = value else {
            buf.writeInt(Int8(0))
            return
        }
        buf.writeInt(Int8(1))
        FfiConverterTypeJsonObject.write(value, into: buf)
    }

    static func read(from buf: Reader) throws -> SwiftType {
        switch try buf.readInt() as Int8 {
        case 0: return nil
        case 1: return try FfiConverterTypeJsonObject.read(from: buf)
        default: throw UniffiInternalError.unexpectedOptionalTag
        }
    }
}

private struct FfiConverterSequenceString: FfiConverterRustBuffer {
    typealias SwiftType = [String]

    static func write(_ value: [String], into buf: Writer) {
        let len = Int32(value.count)
        buf.writeInt(len)
        for item in value {
            FfiConverterString.write(item, into: buf)
        }
    }

    static func read(from buf: Reader) throws -> [String] {
        let len: Int32 = try buf.readInt()
        var seq = [String]()
        seq.reserveCapacity(Int(len))
        for _ in 0 ..< len {
            seq.append(try FfiConverterString.read(from: buf))
        }
        return seq
    }
}

private struct FfiConverterSequenceTypeAvailableExperiment: FfiConverterRustBuffer {
    typealias SwiftType = [AvailableExperiment]

    static func write(_ value: [AvailableExperiment], into buf: Writer) {
        let len = Int32(value.count)
        buf.writeInt(len)
        for item in value {
            FfiConverterTypeAvailableExperiment.write(item, into: buf)
        }
    }

    static func read(from buf: Reader) throws -> [AvailableExperiment] {
        let len: Int32 = try buf.readInt()
        var seq = [AvailableExperiment]()
        seq.reserveCapacity(Int(len))
        for _ in 0 ..< len {
            seq.append(try FfiConverterTypeAvailableExperiment.read(from: buf))
        }
        return seq
    }
}

private struct FfiConverterSequenceTypeEnrolledExperiment: FfiConverterRustBuffer {
    typealias SwiftType = [EnrolledExperiment]

    static func write(_ value: [EnrolledExperiment], into buf: Writer) {
        let len = Int32(value.count)
        buf.writeInt(len)
        for item in value {
            FfiConverterTypeEnrolledExperiment.write(item, into: buf)
        }
    }

    static func read(from buf: Reader) throws -> [EnrolledExperiment] {
        let len: Int32 = try buf.readInt()
        var seq = [EnrolledExperiment]()
        seq.reserveCapacity(Int(len))
        for _ in 0 ..< len {
            seq.append(try FfiConverterTypeEnrolledExperiment.read(from: buf))
        }
        return seq
    }
}

private struct FfiConverterSequenceTypeEnrollmentChangeEvent: FfiConverterRustBuffer {
    typealias SwiftType = [EnrollmentChangeEvent]

    static func write(_ value: [EnrollmentChangeEvent], into buf: Writer) {
        let len = Int32(value.count)
        buf.writeInt(len)
        for item in value {
            FfiConverterTypeEnrollmentChangeEvent.write(item, into: buf)
        }
    }

    static func read(from buf: Reader) throws -> [EnrollmentChangeEvent] {
        let len: Int32 = try buf.readInt()
        var seq = [EnrollmentChangeEvent]()
        seq.reserveCapacity(Int(len))
        for _ in 0 ..< len {
            seq.append(try FfiConverterTypeEnrollmentChangeEvent.read(from: buf))
        }
        return seq
    }
}

private struct FfiConverterSequenceTypeExperimentBranch: FfiConverterRustBuffer {
    typealias SwiftType = [ExperimentBranch]

    static func write(_ value: [ExperimentBranch], into buf: Writer) {
        let len = Int32(value.count)
        buf.writeInt(len)
        for item in value {
            FfiConverterTypeExperimentBranch.write(item, into: buf)
        }
    }

    static func read(from buf: Reader) throws -> [ExperimentBranch] {
        let len: Int32 = try buf.readInt()
        var seq = [ExperimentBranch]()
        seq.reserveCapacity(Int(len))
        for _ in 0 ..< len {
            seq.append(try FfiConverterTypeExperimentBranch.read(from: buf))
        }
        return seq
    }
}

/**
 * Typealias from the type name used in the UDL file to the builtin type.  This
 * is needed because the UDL type name is used in function/method signatures.
 */
public typealias JsonObject = String
private typealias FfiConverterTypeJsonObject = FfiConverterString

/**
 * Top level initializers and tear down methods.
 *
 * This is generated by uniffi.
 */
public enum NimbusLifecycle {
    /**
     * Initialize the FFI and Rust library. This should be only called once per application.
     */
    func initialize() {}
}
